/* Process model C form file: cdpd_mdbs_bis_dec.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_mdbs_bis_dec_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A opnet 7 3A9EC1C5 3A9EC1C5 1 zeus bchenb 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                            ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define	IDLE	1
#define	BUSY	0
#define FAIL	0
#define SUCCESS 1

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		bis;
	} cdpd_mdbs_bis_dec_state;

#define pr_state_ptr            		((cdpd_mdbs_bis_dec_state*) SimI_Mod_State_Ptr)
#define bis                     		pr_state_ptr->bis

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_mdbs_bis_dec_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mdbs_bis_dec (void);
	Compcode cdpd_mdbs_bis_dec_init (void **);
	void cdpd_mdbs_bis_dec_diag (void);
	void cdpd_mdbs_bis_dec_terminate (void);
	void cdpd_mdbs_bis_dec_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mdbs_bis_dec (void)
	{
	int _block_origin = 0;
	FIN (cdpd_mdbs_bis_dec ());
	if (1)
		{
		double		bis_flg;
		double		decode_flg;
		extern FILE *fp;


		FSM_ENTER (cdpd_mdbs_bis_dec)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "cdpd_mdbs_bis_dec () [init enter execs]")
				{
				/* This process correctly sets the busy-idle status flag.	*/
				/* Each mobile must check the status of this flag before	*/
				/* attempting to transmit on the control channel.  Initially*/
				/* this value is IDLE.										*/
				bis = IDLE;
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "cdpd_mdbs_bis_dec () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (set_bis) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "set_bis", "cdpd_mdbs_bis_dec () [set_bis enter execs]")
				{
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cdpd_mdbs_bis_dec)


			/** state (set_bis) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "set_bis", "cdpd_mdbs_bis_dec () [set_bis exit execs]")
				{
				/* In the AMPS specification, IDLE is defined as a value of 1	*/
				/* and busy is defined as 0.  Here we simply monitor the busy	*/
				/* stat of the access channel receiver and set the bit as it	*/
				/* changes.  The mobiles will access this object attribute to	*/
				/* check the value.												*/
				/* Read the value of the busy-idle status and set the status. 	*/
				bis_flg = op_stat_local_read (0);
				
				if (bis_flg == 0.0)
					op_ima_obj_attr_set (op_id_self (), "bis", IDLE);
				
				else
					op_ima_obj_attr_set (op_id_self (), "bis", BUSY);
				
				
				
				}


			/** state (set_bis) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cdpd_mdbs_bis_dec)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_mdbs_bis_dec_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_mdbs_bis_dec_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_mdbs_bis_dec)",
			sizeof (cdpd_mdbs_bis_dec_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_mdbs_bis_dec_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_mdbs_bis_dec_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mdbs_bis_dec_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_mdbs_bis_dec_terminate (void))

	if (1)
		{
		double		bis_flg;
		double		decode_flg;
		extern FILE *fp;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mdbs_bis_dec_svar function. */
#undef bis



void
cdpd_mdbs_bis_dec_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_mdbs_bis_dec_state		*prs_ptr;

	FIN (cdpd_mdbs_bis_dec_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (cdpd_mdbs_bis_dec_state *)gen_ptr;

	if (strcmp ("bis" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bis);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}

